
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.5 to v2.6 patch
----------------------------------------------------------
-- alterations
alter table preferences add column copyright_statement_photo text;
alter table preferences add column bulk_upload_enable char(1) check (bulk_upload_enable in ('t', 'f'));
alter table preferences add column paper integer references paper(identifier);
alter table preferences add column label integer references label(identifier);;

alter table photo add column views integer;
alter table photo add column copyright_statement text;

alter table rating add column comment text;


-- begin: drop users constraint on the submissions
create table submission_temp as
  select identifier, photo_dupe, status, users, date_of_creation, remark
    from submission;

drop view view_submission;
drop table submission;

create table submission (
  identifier            integer not null primary key,
  photo_dupe            integer not null references photo_dupe(identifier),
  status                integer not null references submission_status(identifier),
  users                 integer references users(identifier),
  date_of_creation      timestamp,
  remark                text
);


insert into submission select * from submission_temp;
drop table submission_temp;

create view view_submission as
  select submission.identifier, photo_dupe, photo_dupe.photo, photo_dupe.key,
         (select users.identifier from users where users.identifier = submission.users) as uidentifier,
         (select users.first_name from users where users.identifier = submission.users) as first_name,
         (select users.last_name from users where users.identifier = submission.users) as last_name,
         submission_status.value, submission.date_of_creation, submission.remark
    from submission, photo_dupe, submission_status
   where submission.photo_dupe = photo_dupe.identifier
     and submission.status = submission_status.identifier
   order by submission.date_of_creation, last_name, first_name;

-- end: drop users constraint on the submissions


-- additions
create sequence bulk_upload_id_sequence start 1;

create table system_preferences (
  identifier            integer not null primary key,
  new_user_type         integer not null references user_type(identifier),
  new_user_bulk_upload_enable char(1) check (new_user_bulk_upload_enable in ('t', 'f')),
  new_user_paper        integer references paper(identifier),
  new_user_label        integer references label(identifier)
);

drop view view_rating;

create view view_rating as
  select rating.identifier, photo, users, date_of_creation, value, first_name, last_name, comment
    from rating, users
   where rating.users=users.identifier;
